#!/usr/bin/perl
# gccontent - perl script that analyses the GC content of CDSs on the genome 
# and finds regions with GC content deviation.
#
#
# Written by: Siomar C. Soares, Federal University of Minas Gerais (UFMG), 
#   Laboratory of Celular and Molecular Genetics, Brazil
#
# Date Written: Sep 27, 2010

$arq1 = shift;
open (Text1, "$arq1");
@genome = <Text1>;
close (Text1);
my $gctotal;

chomp @genome;
for $i1(@genome){
	@gctotal = split (/[ ]+/, $i1);
	if ($gctotal[0] !~ /^\#/){$gctotal = $gctotal[1];}
		}


$arq2 = shift;
open (Text2, "$arq2");
@orfgc = <Text2>;
close (Text2);
my @gc;
my $sumdev;
my $cc;
$cc=0;
$sumdev=0;

chomp @orfgc;
for $i2(@orfgc){
	@gc = split (/[ ]+/, $i2);
	if ($gc[0] !~ /^\#/){$sumdev=$sumdev+(($gc[1]-$gctotal)**2); $cc++;}
}
$stdev=sqrt($sumdev/$cc);
$reflow=$gctotal-(1.5*$stdev);
$refhigh=$gctotal+(1.5*$stdev);


for $i3(@orfgc){
	@hgt = split (/[ ]+/, $i3);
		{
		if ($hgt[0] !~ /^\#/)	
			{$out[0]=$hgt[0];
			if ($hgt[1]<$reflow)	
				{$out[1]="LOW_GC";}
			if ($hgt[1]>$refhigh)	
				{$out[1]="HIGH_GC";}
			if (($hgt[1]>$reflow)&&($hgt[1]<$refhigh))
				{$out[1]="NORMAL";}
			print "$out[0]"."\t"."$out[1]"."\n";
			}
		}
	       }
